functor Registry(
	    ): REGISTRY = struct

type 'a registry = (string * ('a->unit)) list

val new = nil

fun register registry name callback = 
  (name,callback)::registry

exception NotRegistered of string

fun poke_one registry name v = 
  let fun f [] found = if not found then raise NotRegistered(name) else ()
        | f ((n,callback)::tl) found = 
        	 if name=n 
                    then (callback v; f tl true)
        	    else f tl found
  in f registry false
  end

fun poke_all registry v =
  let fun f [] = ()
        | f ((n,callback)::tl) = (callback v; f tl)
  in f registry
  end

end
